﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI.Diagrams;
using Telerik.Windows.Diagrams.Core;

namespace _1150801_RadDiagramRadialLayout
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //DiagramConstants.RoutingGridSize = 500;
            //Telerik.Windows.Diagrams.Core.SugiyamaSettings settings = new Telerik.Windows.Diagrams.Core.SugiyamaSettings()
            //{
            //    HorizontalDistance = 50,
            //    VerticalDistance = 20,
            //    Orientation = Telerik.Windows.Diagrams.Core.Orientation.Horizontal,
            //    TotalMargin = new Telerik.Windows.Diagrams.Core.Size(20, 20),
            //    ShapeMargin = new Telerik.Windows.Diagrams.Core.Size(10, 10),
            //};
            //
            //this.radDiagram1.SetLayout(Telerik.Windows.Diagrams.Core.LayoutType.Sugiyama, settings);

            IShape root = this.radDiagram1.Shapes[0];
            var connectorRightUp = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(1, 0.25), Name = root.Name + "Connector1" };
            var connectorRightDown = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(1, 0.75), Name = root.Name + "Connector2" };
            var connectorLeftUp = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0, 0.25), Name = root.Name + "Connector3" };
            var connectorLeftDown = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0, 0.75), Name = root.Name + "Connector4" };

            root.Connectors.Add(connectorRightUp);
            root.Connectors.Add(connectorRightDown);
            root.Connectors.Add(connectorLeftUp);
            root.Connectors.Add(connectorLeftDown);

            var connectorUpLeft = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0.25, 0), Name = root.Name + "Connector5" };
            var connectorUpRight = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0.75, 0), Name = root.Name + "Connector6" };
            var connectorDownLeft = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0.25, 1), Name = root.Name + "Connector7" };
            var connectorDownRight = new RadDiagramConnector() { Offset = new Telerik.Windows.Diagrams.Core.Point(0.75, 1), Name = root.Name + "Connector8" };

            root.Connectors.Add(connectorUpLeft);
            root.Connectors.Add(connectorUpRight);
            root.Connectors.Add(connectorDownLeft);
            root.Connectors.Add(connectorDownRight);

            Telerik.Windows.Diagrams.Core.TreeLayoutSettings settings = new Telerik.Windows.Diagrams.Core.TreeLayoutSettings()
            {
                TreeLayoutType = Telerik.Windows.Diagrams.Core.TreeLayoutType.RadialTree,
                VerticalDistance = 20,
            };
            settings.Roots.Add(root);
            this.radDiagram1.SetLayout(Telerik.Windows.Diagrams.Core.LayoutType.Tree, settings);

            this.radDiagram1.RouteConnections = true;
            this.radDiagram1.RoutingService.Router = new AStarRouter(this.radDiagram1.DiagramElement) { WallOptimization = true };
            this.radDiagram1.RoutingService.FreeRouter = new AStarRouter(this.radDiagram1.DiagramElement) { WallOptimization = true };
        }
    }
}
